unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Grids, Types;

type

  { TForm1 }

  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    procedure FormActivate(Sender: TObject);
    procedure StringGrid1Click(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; aCol, aRow: Integer;
      aRect: TRect; aState: TGridDrawState);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormActivate(Sender: TObject);
begin
  StringGrid1.Cells[1,1]:='ABC';
end;

procedure TForm1.StringGrid1Click(Sender: TObject);
begin
  if (StringGrid1.Cells[4,StringGrid1.Row]='') then begin
      StringGrid1.Cells[4,StringGrid1.Row]:='1';
  end else begin
      StringGrid1.Cells[4,StringGrid1.Row]:='';
  end;
end;

procedure TForm1.StringGrid1DrawCell(Sender: TObject; aCol, aRow: Integer;
  aRect: TRect; aState: TGridDrawState);
begin

   if (gdFixed in aState) then exit;


   if (StringGrid1.Cells[4,ARow]='1') then begin
       TStringGrid(Sender).Canvas.Brush.Color:=clHighlight;
       TStringGrid(Sender).Canvas.Font.Color:=clWhite;
   end else begin
       TStringGrid(Sender).Canvas.Brush.Color:=clWindow;
       TStringGrid(Sender).Canvas.Font.Color:=clBlack;
   end;


   TStringGrid(Sender).Canvas.FillRect(aRect);

   StringGrid1.Canvas.TextRect (aRect, aRect.Left, aRect.Top, StringGrid1.Cells[ACol,ARow]);


end;

end.

